#include <limits.h>
#include <stdio.h>
#include "RC4.h"

/*************************************************************/

int main(void)
{
	unsigned char Key[5] = { 0x34, 0x56, 0x89, 0x9A, 0xD2 };
	
	unsigned int Cycles = UINT_MAX;

	for (unsigned int i = 0; i < 64; i++) {
		unsigned int NewCycles = TimeIt(Key);
		if (NewCycles < Cycles)
			Cycles = NewCycles;
	}

	printf("Clock cycles required: %u\n", Cycles);
	printf("Thus %.02f cycles per cryptovariable\n", (double)Cycles / 256.0);
	printf("Or %.02f cycles per runup iteration\n", (double)Cycles / 65536.0);

	printf("\n");
	printf("Expected speed at 500 MHz: %.01f cryptovariables per second\n\n", 500000000.0 / ((double)Cycles / 256.0));
	return 0;
}